#include <stdlib.h>
#include <stdio.h>
#include "huff.h"

/*global variables*/
extern code_inf code[NNODE];
extern tree_node temp[NNODE];
extern tree_node* ptemp[NNODE];
float freq[]={0.01,0.04,0.05,0.11,0.19,0.20,0.4};

void generate_code()
{
    int i = 0;

    /*initiate the queue*/
    for(i=0;i<nchar;i++){
        temp[i].symbol = 'a'+i;
        temp[i].freq = freq[i];
        temp[i].isleaf=1;
        temp[i].left=temp[i].right=temp[i].parent=NULL;
        ptemp[i]=&temp[i];
    }
    /*sort the queue by frequency*/
    qsort(ptemp,7,sizeof(tree_node*),compare);
    /*build tree*/
    tree_node*lc, *rc;
    for(i=0;i<nchar-1;i++){
            lc = ptemp[2*i];
            rc = ptemp[2*i+1];
            ptemp[nchar+i]=&temp[nchar+i];
            ptemp[nchar+i]->symbol = 0;
            ptemp[nchar+i]->freq = lc->freq + rc->freq;
            ptemp[nchar+i]->left = ptemp[2*i];
            ptemp[nchar+i]->right = ptemp[2*i+1];
            ptemp[nchar+i]->parent = NULL;
            ptemp[nchar+i]->isleaf=0;
            ptemp[2*i]->parent=ptemp[2*i+1]->parent=ptemp[nchar+i];
            qsort(ptemp+2*(i+1),6-i,sizeof(tree_node*),compare);
    }

    /*get code len for each node*/
    tree_node*code_temp[NNODE];
    for(i=0;i<NNODE;i++)
       code_temp[i]=ptemp[i];
    for(i=0;i<NNODE;i++){
            code[i].len=0;
        while(code_temp[i]->parent){
            code[i].len++;

            code_temp[i]=code_temp[i]->parent;
        }
    }
    /*generate code*/
    int j,clen;
    for(i=0;i<NNODE;i++){
        code_temp[i]=ptemp[i];
    }
    for(i=0;i<NNODE;i++){
        clen=code[i].len-1;
        for(j=0;j<code[i].len;j++){

                code[i].code_word[clen-j]=(code_temp[i]==code_temp[i]->parent->left)?'0':'1';
                code_temp[i]=code_temp[i]->parent;
        }
    }
}

int encode(char chara)
{

        int i=0;
        while(chara!=ptemp[i]->symbol)
        i++;
        return i;
}

int compare(const void*s1, const void*s2)
{
    tree_node*c1 = *(tree_node**)s1;
    tree_node*c2 = *(tree_node**)s2;
    if(c1->freq > c2->freq)
        return 1;
    else if(c1->freq == c2->freq)
        return 0;
    else
    return -1;
}




